package lightcontainer.interfaces;

import lightcontainer.domains.Task;
import lightcontainer.domains.client.StoreProcessor;
import lightcontainer.domains.server.MulticastServerListener;
import lightcontainer.repository.StoreProcessorRepository;

/**
 * A communication interface between a {@link StoreProcessor} and the {@link StoreProcessorRepository}.
 */
public interface MulticastSPR {
    /**
     * Setter, allow to define the ServerListener of a repository.
     * @param server ServerListener to set as default.
     */
    void setServerListener(MulticastServerListener server);

    /**
     * Add a StorePorcessor.
     * @param store Store processor to add.
     */
    boolean addStore(StoreProcessor store);

    String findDomain(Task task);

    void assignTask(String stor, Task task);

    boolean hasDomain(String domain);

    int domainCount();

    /**
     * Déconnecte tous les SBE
     */
    void disconnectDomains();

    /**
     * Permet de déconnecter un SBE
     * @param domain Le domaine du SBE à déconnecter
     */
    void closeStore(String domain);
}
